Library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

Entity DR is
	port(input:in std_logic_vector(7 downto 0);
	     clr, clk, inr, load, read:in std_logic;
	     output:out std_logic_vector(7 downto 0));
End DR;

Architecture DR_arch of DR is
	Signal input_signal, output_signal, mem_contents:std_logic_vector(7 downto 0);
	
	begin
		input_signal <= input;
		output <= output_signal;
		
		clkpulse:process(clk, inr, load, clr, read)
		begin
			if(clk'event and clk ='1') then	--Positive edge triggered
				if(load = '1') then	
					mem_contents <= input_signal; --Load from bus
				else
					if (inr ='1') then
						mem_contents <= (mem_contents + 1);
					else
						if(clr = '1') then
							mem_contents <= "00000000";
						end if;
					end if;
				end if;
				
				if(read ='1') then
					output_signal <= mem_contents;
				end if;
			end if;
			
			
		end process;
		
		
end DR_arch;
				
	
